      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id MicroFocus.COBOL.Examples.Support.Email.
      $if JVMGEN set
       01 emailRegexPatternString  string static value "[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}".
       01 emailRegexPattern        type java.util.regex.Pattern static value null. 
      $end
       01 emailAddress             string property with no set as "Address". 
       01 emailName                string property with no set as "Name". 
       01 domain                   string property with no set as "Domain". 
       
       method-id New (#address as string). 
           set #address to #address::TrimSpaces()
           if #address = null or size of #address = 0 or not Validate(#address)
               raise new InvalidArgumentException("Email address not in correct format") 
           end-if
      *>   We now know email address is in correct format so safe to use unstring 
      *>   to separate parts
           unstring #address  delimited by "@"
                   into emailName domain 
           set emailAddress to #address   
       end method.  
       
       method-id Validate(#address as string) returning result as condition-value static.
           set result to ValidateHelper(#address)
       end method.  
      
      $if JVMGEN set
       method-id ValidateHelper(#address as string) returning result as condition-value static.
           declare matcher as type java.util.regex.Matcher 
           set matcher = RegexPattern::matcher(#address)  
           set result to matcher::matches()
       end method.
 
       property-id RegexPattern type java.util.regex.Pattern static. 
           getter.
               if emailRegexPattern = null then 
                   set emailRegexPattern to 
                       type java.util.regex.Pattern::compile(emailRegexPatternString
                       type java.util.regex.Pattern::CASE_INSENSITIVE b-or
                       type java.util.regex.Pattern::UNICODE_CASE)
               end-if
               set property-value to emailRegexPattern
       end property.
       
      $else
       method-id ValidateHelper(#address as string) returning result as condition-value static.
           set result to true    
           declare mail as type System.Net.Mail.MailAddress  
           try 
                set mail to new System.Net.Mail.MailAddress(#address)
           catch e as type FormatException
               set result to false
           end-try
       end method. 
      $end-if
       
      $if JVMGEN set
       method-id toString() returning result as string override.
           set result to ToString()
       end method.
      $end
       method-id ToString()  returning result as string 
      $if NOJVMGEN set
       override
      $end
       .
           set result to emailAddress
       end method.  
       
       end class.
