      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       program-id Leases. 
       working-storage section. 
       01 today                        type IDate.
       01 nextWeek                     type IDate. 
       01 rentalProperties             list[type RentalProperty]. 
       01 leases                       list[type Lease]. 
       01 aLease                       type Lease. 
       01 aHouse                       type RentalProperty. 
       01 anApartment                  type RentalProperty. 
       01 landlord                     type Landlord. 
       01 person1                      type Tenant.
       01 person2                      type Tenant.       
       
       procedure division. 
      *>----------CREATE DATA-------------<
      *>   Create people
           set landlord to new Landlord("Gritpype Thynne" "gritpype.thynne@examples.com") 
           set person1 to new Tenant("Jules Bona" "jules.bona@example.com") 
           set person2 to new Tenant("Neddie Seagoon" "neddie.seagoon@example.com") 
      
      *>   Create properties    
           create rentalProperties   *> a list for storing the properties.
           set aHouse to new RentalProperty(new Address("15 Lee Terrace", "Lewisham", 
                                                        "London", "SE14 7TT"))
           set aHouse::MonthlyRent to 950
           set aHouse::Owner to landlord
           write rentalProperties from aHouse
           set aHouse to new RentalProperty(new Address("23 Railway Cuttings", "East Cheam", 
                                                        "London", "SM23 8RX"))
           set aHouse::MonthlyRent to 780
           set aHouse::Owner to landlord
           write rentalProperties from aHouse
           set anApartment to new RentalProperty(new Address("17 Acacia Avenue", 
                                                             "Chiswick", "London", "W13 2AN"))
           set anApartment::MonthlyRent to 550
           set aHouse::Owner to landlord
           write rentalProperties from anApartment
      *>   Create a list for holding all leases.
           create leases 
      *>----------DO SOMETHING WITH THE DATA--------    
      *>   Display all the properties stored in our list
           perform varying nextProperty as type RentalProperty through rentalProperties
               display nextProperty::GetDisplayValue()
           end-perform
           
           set today to type DateFactory::GetCurrentDate()
      *>   Create a lease starting today and running for 90 days
           set aLease to new Lease(today, 90, rentalProperties[0], person1)
           display aLease::Start space aLease::End
           write leases from aLease
      *>   Create a lease starting next week and running for 6 months
           set nextWeek to today::Add(7)
           display nextWeek
           set aLease to new Lease(today, 90, rentalProperties[1], person2)
           write leases from aLease
      *>   display all the leases
           perform varying nextLease as type Lease through leases
               display nextLease::GetDisplayValue()
           end-perform
      *>   display the properties again - the ones that have been let show as leased
           perform varying nextProperty as type RentalProperty through rentalProperties
               display nextProperty::GetDisplayValue()
           end-perform

      *>   cancel the first lease and remove it from the list
           invoke leases[0]::Cancel()
           
           delete leases key 0 
           display size of leases  *> shows 1 as one lease has been removed.

       end program.
