      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id MicroFocus.COBOL.Examples.Lettings.Lease public.
       
       01 #Start                   type IDate property with no set. 
       01 #End                     type IDate property with no set.  
       01 cancelled                condition-value.
       01 #Property                type RentalProperty property with no set. 
       01 Tenant                   type Tenant property with no set.  
       01 #Id                      string property with no set.  
       
       method-id New(#start as type IDate, expiry as type IDate 
                     leased as type RentalProperty, t as type Tenant).
           set self::Start to #start
           set self::End to expiry
           set self::Property to leased
           invoke leased::LeaseProperty(self)
           set tenant to t 
           invoke tenant::StartLease(self)
           set self::Id to type MicroFocus.COBOL.Examples.Support.Guid::GetNewGuid()
       end method.

       method-id New(#start as type IDate period as binary-long
                     leased as type RentalProperty t as type Tenant ). 
           invoke self::New( #start #start::Add(period) leased t)
       end method. 

       method-id Cancel. 
           set cancelled to true
           invoke #property::CancelLease()
           invoke tenant::CancelLease()
       end method.
       
       method-id IsCancelled returning result as condition-value. 
           set result to cancelled
       end method. 
       
      *>
      *> Check that the lease term is not over and the lease has not been cancelled.
      *>
       method-id IsActive() returning result as condition-value.
           set result to type DateFactory::GetCurrentDate()::Compare(#end) <= 0 
                              and not self::IsCancelled()
       end method.
       
       method-id ExtendLease(byDays as binary-long) returning result as type IDate. 
           set #end to #end::Add(byDays)
           set result to #end
       end method. 
       
       method-id GetDisplayValue returning result as string. 
           set result to #Property::Address::ShortValue 
                         & " Expiry " & #end & " Tenant " & tenant::Email
       end method. 
       
       end class.
 