      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id MicroFocus.COBOL.Examples.Lettings.RentalProperty public.
       01 #Address                     type Address property with no set.  
       01 MonthlyRent                  binary-long property. 
       01 #Lease                       type Lease property with no set.   
       01 Owner                        type Landlord property.  

       method-id New(#address as type Address). 
           set self::Address to #address
       end method. 
       
       method-id IsAvailable() returning result as condition-value. 
      *>   Return true if there is no lease. 
           set result to Lease = null or not Lease::IsActive()
       end method.
       
        method-id LeaseProperty(lease as type Lease) internal.
           if not IsAvailable()
               raise new LeaseException("Not yet available")
           end-if
           set self::Lease to lease
       end method. 
       
       method-id CancelLease() internal.
           set Lease to null
       end method. 
       
       method-id GetDisplayValue returning result as string. 
           declare rentalStatus as string 
           if IsAvailable()
               set rentalStatus to "Free"
           else    
               set rentalStatus to "Leased" 
           end-if
           set result to rentalStatus & " | " & "Rent: " & monthlyRent 
                          & " | Address: " & #Address::ShortValue
       end method. 
       
       end class.
       